const createTaffyDriver = require('./taffy')

const createTaffyMock = (db = []) => {
  const taffy = ({ id }) => ({
    first: () => db.find(e => e.id === id),
  })
  taffy.insert = data => db.push(data)

  return taffy
}

describe('taffy driver', () => {
  it('save', () => {
    const data = { some: 'DATA' }
    const id = 1
    const db = []
    const taffy = createTaffyMock(db)
    const taffyDriver = createTaffyDriver({ taffy })
    taffyDriver.save(id, data)
    expect(db).toEqual([{ id, data }])
  })

  it('load', () => {
    const data = { some: 'DATA' }
    const id = 1
    const db = [{ id, data }]
    const taffy = createTaffyMock(db)
    const taffyDriver = createTaffyDriver({ taffy })
    const loadedData = taffyDriver.load(id)
    expect(loadedData).toEqual(data)
  })
})
